export enum UserPermissionId {
  /**
   * @deprecated
   */
  MAIN_PAGE = 1,
  /**
   * @deprecated
   */
  USER_PAGE = 2,
  /** 访问后台管理页面 */
  MANAGE_PAGE = 3,
  /** 管理用户权限 */
  MANAGE_USER = 4,
}
export enum ClubPermissionId {
  /** 管理社团信息权限 */
  MANAGE_CLUB = 1,
  /** 更改社团成员权限 */
  CHANGE_CLUB = 2,
  /** 查看社团主页权限 */
  CLUB_PAGE = 3,
  /** 社团发帖权限 */
  POST_CLUB = 4,
}
export enum UserAuthId {
  /** 游客 */
  GUEST = 1,
  /** 普通用户 */
  USER = 2,
  /** 管理员 */
  ADMIN = 3,
}
export type AuthNameRecord<T extends number> = Record<T, string> &
  Record<number, string | undefined>;
export const userAuthNameMapping: AuthNameRecord<UserAuthId> = {
  [UserAuthId.GUEST]: '游客',
  [UserAuthId.USER]: '普通用户',
  [UserAuthId.ADMIN]: '管理员',
};
export enum ClubAuthId {
  /** 社长 */
  LEADER = 1,
  /** 副社长 */
  SUB_LEADER = 2,
  /** 社员 */
  MEMBER = 3,
}
export const clubAuthNameMapping: AuthNameRecord<ClubAuthId> & {
  NONE: string;
} = {
  [ClubAuthId.LEADER]: '社长',
  [ClubAuthId.SUB_LEADER]: '副社长',
  [ClubAuthId.MEMBER]: '社员',
  NONE: '无',
};
