type ZipSimple<T extends readonly Iterable<unknown>[]> = {
  [P in keyof T]: T[P] extends Iterable<infer U> ? U : never;
};
type FixedTuple<T = unknown> = (readonly [T, ...T[]] & readonly [...T[], T]) | readonly [];
type ZipTuple1<T extends FixedTuple[]> = {
  [I in keyof T]: T[I] extends FixedTuple
    ? T[I] extends readonly [infer R, ...infer S extends FixedTuple]
      ? [R, S]
      : never
    : never;
};
type IndexGetter<T extends unknown[][], I extends keyof T[number]> = {
  [I2 in keyof T]: T[I2][I];
};
type ZipTuple2<T extends [unknown, FixedTuple][]> = true extends {
  [I in keyof T]: [T[I]] extends [never]
    ? true
    : true extends {
          [I2 in keyof T[I]]: [T[I][I2]] extends [never] ? true : false;
        }[keyof T[I]]
      ? true
      : false;
}[keyof T]
  ? never
  : [IndexGetter<T, 0>, IndexGetter<T, 1>];
type ZipTuple3<T extends [unknown[], FixedTuple[]]> = [T] extends [never]
  ? []
  : T extends [[], []]
    ? []
    : [T[0], ...ZipTuple<T[1]>];
type ZipTuple<T extends FixedTuple[]> = ZipTuple3<ZipTuple2<ZipTuple1<T>>>;
type Zip<T extends readonly Iterable<unknown>[]> = T extends FixedTuple[]
  ? ZipTuple<T>
  : ZipSimple<T>;
export function* zip<T extends readonly Iterable<unknown>[]>(
  ...iterables: T
): Generator<Zip<T>, void, unknown> {
  const its = iterables.map((it) => Iterator.from(it));
  while (true) {
    const nexts = its.map((it) => it.next());
    if (nexts.some(({ done }) => done)) {
      return;
    }
    yield nexts.map(({ value }) => value) as any;
  }
}
