import type { Primitive } from 'zod';
export type MaybePromise<T> = T | Promise<T>;
export type MaybeArray<T, R extends boolean = false> = T | (R extends false ? T[] : readonly T[]);
export type ValueOf<T extends object> = T[keyof T];
export type StrictOmit<T, K extends keyof T> = Omit<T, K>;
export type Override<
  T extends object,
  R extends Partial<T> | {} = {}, // HACK 防止ts(2559)错误
  O extends keyof T = never,
> = Omit<T, keyof R | O> & R;
export type Rename<
  T extends Record<keyof any, unknown>,
  R extends Partial<Record<keyof T, keyof any>>,
> = Omit<T, keyof R> & {
  [P in keyof R as Exclude<R[P], undefined>]: T[P]; // HACK 防止ts(2322)错误
};
export type Nullable<T = never> = T | null | undefined;
export type ComparablePrimitive = Exclude<Primitive, symbol>;
export type Exposed<T> = {
  [P in keyof T]: T[P];
};
export type ValidKey<T, O extends Record<string, unknown>> = {
  [P in keyof O]: O[P] extends T ? P : never;
}[keyof O];
